<script lang="ts" setup>
  const props = withDefaults(defineProps<{
    disabled?: boolean,
    href?: string
    target?: string
    variant?: 'primary' | 'secondary'
    size?: 'normal' | 'big'
  }>(), {
    variant: 'primary',
    size: 'normal'
  })

  const emit = defineEmits<{
    (event: 'clicked'): void
  }>()
</script>

<template>
  <NuxtLink v-if="href" :to="href" :target="target">
    <button
      :disabled="disabled"
      @click="emit('clicked')"
      class="p-4 shadow-xl font-bold py-2 px-4 rounded transition-all border-b-4 border-dark"
      :class="[
        size === 'big' && 'h-24 text-xl border-b-8 active:translate-y-2',
        variant === 'primary' && 'bg-secondary',
        variant === 'secondary' && 'bg-primary text-light',
        disabled && 'bg-opacity-60 cursor-not-allowed',
        !disabled && 'hover:bg-opacity-80 active:shadow-none active:border-none active:translate-y-1 hover:border-dark'
      ]"  
      >
      <slot />
    </button>
  </NuxtLink>
  <button
    v-else
    :disabled="disabled"
    @click="emit('clicked')"
    class="bg-secondary p-4 shadow-lg font-bold py-2 px-4 rounded transition-all  border-b-4 border-dark"
    :class="[
      disabled && 'bg-opacity-60 cursor-not-allowed',
      !disabled && 'hover:bg-opacity-80 active:shadow-none active:border-none active:translate-y-1 hover:border-dark'
    ]"  
    >
    <slot />
  </button>
</template>

<style lang="scss" scoped></style>